----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    
-- Design Name: 
-- Module Name:
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: divide the clock by 5
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity clk_div5 is
  port (  clk				:in std_logic;
		  clk_out			:out std_logic:='0');
		  
end clk_div5;

architecture Structural of clk_div5 is
  signal set_clk_out, reset_clk_out: std_logic:='0';
  signal counter :std_logic_vector(2 downto 0):="000";
begin
 
process (clk)
 begin	
	if (clk'event and clk='1') then		-- rising edge of clock
		if (counter(2)='1') then		-- check for counter=4 (100 binary, but we check only bit2) 
			counter<="000";				--	reset counter value
			set_clk_out <= not reset_clk_out;	-- set clk_out to 1
		else counter<=counter+1;
		end if;		
	end if;	
		
end process;

process (clk)
 begin	
	if (clk'event and clk='0') then		-- falling edge of clock		
		if (counter(1)='1') then		-- check for counter=2 (10 binary) and since we are in a falling edge this is actually 2,5 
			reset_clk_out <= set_clk_out;	-- set clk_out to 0
		end if;
	end if;	
		
end process;

clk_out <= set_clk_out xor reset_clk_out;

end Structural;
